#include "akm_defs.h"

string
    SubWindowOpened1;
int
    sub_window_control;
int
    akm_time_cnt;

////////////////////////////////////////////////
string _string_(string tstring) { return tstring; }

////////////////////////////////////////////////
void _CloseCurrSubWindow()
{

  if( //sub_window_control && 
      stdStrCmp(SubWindowOpened1,"") )
  {
     print "CloseSubWnd:", SubWindowOpened1,"\n";
     akmShowWindow(SubWindowOpened1,SW_HIDE);
     SubWindowOpened1 = _string_("");
  }
}

////////////////////////////////////////////////
////////////////////////////////////////////////
void _OpenSubWindow( string winname1 )
{
//  akmPrint( "SubWindowOpened:" ); akmPrint( SubWindowOpened ); akmPrint( "\n" );
//  akmPrint( stdItoS("stdStrCmp result: [%d]\n",stdStrCmp(SubWindowOpened,"")) );

  if( sub_window_control && 
      stdStrCmp(SubWindowOpened1,winname1) != 0  )
  {
    _CloseCurrSubWindow();

    if( stdStrCmp(winname1,"") )
    {
      print "OpenSubWnd:", winname1, "\n";
      akmShowWindow(winname1,SW_SHOWDEFAULT);
      SubWindowOpened1 = winname1;
    }

  }

}

////////////////////////////////////////////////
////////////////////////////////////////////////
void _SetParamI( string pname, int pvalue)
{
  float arrParamData      [MAX_PARAMDATA_ARRAY_SIZE];
  arrParamData[0] = stdFloat(pvalue);
  akmSetParamDataFloat(pname, arrParamData, 1);
}

////////////////////////////////////////////////
////////////////////////////////////////////////
int _GetParamI( string pname)
{
  float arrParamData      [MAX_PARAMDATA_ARRAY_SIZE];
  akmGetParamDataFloat(pname, arrParamData);
  return stdInt(arrParamData[0]);
}

////////////////////////////////////////////////
////////////////////////////////////////////////
void _SetParamF( string pname, float pvalue)
{
  float arrParamData      [MAX_PARAMDATA_ARRAY_SIZE];
  arrParamData[0] = pvalue;
  akmSetParamDataFloat(pname, arrParamData, 1);
}

////////////////////////////////////////////////
////////////////////////////////////////////////
float _GetParamF( string pname)
{
  float arrParamData      [MAX_PARAMDATA_ARRAY_SIZE];
  akmGetParamDataFloat(pname, arrParamData);
  return arrParamData[0];
}


////////////////////////////////////////////////
////////////////////////////////////////////////
int _WriteParamI( string pname, int pvalue )
{
  int arrCmdParams[MAX_SERVICE_DATA_SIZE];
  int arrParamIntDescr[PARAM_INTDESCR_ARRAY_SIZE];
  int paddr;
  int fldn,size;

  fldn =  akmGetParamIntDescr(
    pname,            // STK_PARAM_STRING sParamName,                                  // IN
    arrParamIntDescr  // STK_PARAM_INT    arrParamIntDescr[PARAM_INTDESCR_ARRAY_SIZE]  // OUT
    );

  paddr = arrParamIntDescr[P_ADDRESS];

  //  SBYTE, UBYTE, SWORD, UWORD, SLONG, ULONG, FLOAT or DOUBLE
  if( arrParamIntDescr[P_SCALARTYPE] < 2 ) size = 1;
  else if( arrParamIntDescr[P_SCALARTYPE] < 4 ) size = 2;
  else size = 4;

  arrCmdParams[0] = pvalue&0x00FF;
  arrCmdParams[1] = (pvalue>>8)&0x00FF;
  arrCmdParams[2] = (pvalue>>16)&0x00FF;
  arrCmdParams[3] = (pvalue>>24)&0x00FF;

  fldn =  akmDataSrcWriteData(
    MODEL_DEFNAME,   // STK_PARAM_STRING sModelName,                     // IN
    paddr,           // STK_PARAM_INT    dataAddress,                    // IN
    size,            // STK_PARAM_INT    dataSize,                       // IN
    arrCmdParams );  // STK_PARAM_INT    arrData[MAX_SERVICE_DATA_SIZE]  // IN

  print "akmDataSrcWriteData: ", fldn, "\n";

  return fldn;
}


////////////////////////////////////////////////
////////////////////////////////////////////////
int _ReadParamI( string pname )
{
  int arrCmdParams[MAX_SERVICE_DATA_SIZE];
  int arrParamIntDescr[PARAM_INTDESCR_ARRAY_SIZE];
  int paddr = 0x0;
  int fldn,size;
  int pvalue = 0;

  fldn = akmGetParamIntDescr(
    pname,            // STK_PARAM_STRING sParamName,                                  // IN
    arrParamIntDescr  // STK_PARAM_INT    arrParamIntDescr[PARAM_INTDESCR_ARRAY_SIZE]  // OUT
    );

  paddr = arrParamIntDescr[P_ADDRESS];

  if( arrParamIntDescr[P_SCALARTYPE] < 2 ) size = 1;
  else if( arrParamIntDescr[P_SCALARTYPE] < 4 ) size = 2;
  else size = 4;
 
  print "_ReadParamI:", pname, " ", stdItoS("ADR:%08x", paddr ), stdItoS("(%d)", size ),"\n";

  fldn = akmDataSrcReadData(
    MODEL_DEFNAME, // STK_PARAM_STRING sModelName,                     // IN
    paddr,         // STK_PARAM_INT    dataAddress,                    // IN
    size,          // STK_PARAM_INT    dataSize,                       // IN
    arrCmdParams); // STK_PARAM_INT    arrData[MAX_SERVICE_DATA_SIZE]  // OUT

  print "akmDataSrcReadData: ", fldn, "\n";

  if(fldn) 
  { 
//    print "arrResult:";
//    for( int i = 0; i<size; i++ )
//      print stdItoS(" %02x",arrCmdParams[i]);
//    print "\n";
    if( size == 1 )
      pvalue = (arrCmdParams[0]&0xFF);
    else if( size == 2 )
     pvalue = ((arrCmdParams[1]<<8)&0xFFFFFF00)|(arrCmdParams[0]&0xFF);
  }

  return pvalue;
}


////////////////////////////////////////////////
//
////////////////////////////////////////////////
void OscillOnOff()
{
  int butt_state = _ReadParamI( "OscEn" );

  if( butt_state ) butt_state = 0;
  else butt_state = 1;

  _WriteParamI( "OscEn", butt_state );

}


////////////////////////////////////////////////
//
////////////////////////////////////////////////
int _IncParam( string pname, int increment )
{
  int state = _ReadParamI( pname );

  state += increment;

  _WriteParamI( pname, state );

  return state;
}

////////////////////////////////////////////////
int _CopyParam( string pname1, int dynpar1, string pname2, int dynpar2 )
{
  int new_value;

  if( dynpar2 ) new_value = _ReadParamI( pname2 );
  else          new_value = _GetParamI( pname2 );

  if( dynpar1 ) _WriteParamI (pname1, new_value );
  else          _SetParamI( pname1, new_value );

  return new_value;
}

////////////////////////////////////////////////
int _SetParamValue( string pname1, int dynpar1, int new_value )
{

  if( dynpar1 ) _WriteParamI (pname1, new_value );
  else          _SetParamI( pname1, new_value );

  return new_value;
}

////////////////////////////////////////////////
float _CopyParamM( string pname1, int dynpar1, string pname2, int dynpar2, float mast )
{
  float new_value_f;

  if( dynpar2 ) { new_value_f = _ReadParamI( pname2 );  new_value_f /= mast ; }
  else          new_value_f = _GetParamF( pname2 ) ;

  if( dynpar1 ) _WriteParamI (pname1,   new_value_f * mast );
  else          _SetParamF( pname1, new_value_f );

  return new_value_f;
}

////////////////////////////////////////////////
void OscillPeriod_NEXT()
{
  _IncParam( "OscPeriod", 1 );
}
////////////////////////////////////////////////
void OscillPeriod_PREV()
{
  _IncParam( "OscPeriod", -1 );
}
////////////////////////////////////////////////
void OscillPeriod_SET()
{
  _CopyParam( "OscPeriod", 1, "OscSelPeriod", 0);
}


////////////////////////////////////////////////
void OscillTrigger_NEXT()
{
  _IncParam( "OscTrigger", 1 );
}
////////////////////////////////////////////////
void OscillTrigger_PREV()
{
  _IncParam( "OscTrigger", -1 );
}
////////////////////////////////////////////////
void OscillTrigger_SET()
{
  _CopyParam( "OscTrigger", 1, "OscSelTrigger", 0);
}


////////////////////////////////////////////////
void OscillSource_NEXT()
{
  _IncParam( "OscData", 1 );
}
////////////////////////////////////////////////
void OscillSource_PREV()
{
  _IncParam( "OscData", -1 );
}

////////////////////////////////////////////////
void  _openSubOscillWnd( int SourceSel )
{

  if( akmIsWindowVisible("2") )
  {

    print "_openSubOscillWnd (",SourceSel,")\n";

    if( SourceSel == 0 || 
      SourceSel == 1 ||
      SourceSel == 2 ||
      SourceSel == 3 )
      _OpenSubWindow("WND_ISV");
    else if( 
      SourceSel == 4 || 
      SourceSel == 5 )
      _OpenSubWindow("WND_USV");
    else if( 
      SourceSel == 6 || 
      SourceSel == 7 )
      _OpenSubWindow("WND_USYN");
  }

  return;
}


////////////////////////////////////////////////
void OscillSource_SET()
{
  print "OscillSource_SET()\n";

  int SourceSel = _CopyParam( "OscData", 1, "OscSelData", 0);

  _openSubOscillWnd(SourceSel);

  return;
}


////////////////////////////////////////////////
void OscillViewCh11()
{
  print "OscillViewCh11()\n";

  // Source
  _SetParamValue( "OscData", 1, 0 );
  _SetParamValue( "OscSelData", 0, 0 );
  _openSubOscillWnd(0);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 26);
  _SetParamValue( "OscSelTrigger", 0, 26);
  // start
  _WriteParamI( "OscEn", 1 );

}

////////////////////////////////////////////////
void OscillViewCh12()
{
  print "OscillViewCh12()\n";

  // Source
  _SetParamValue( "OscData", 1, 0 );
  _SetParamValue( "OscSelData", 0, 0 );
  _openSubOscillWnd(0);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 27);
  _SetParamValue( "OscSelTrigger", 0, 27);
  // start
  _WriteParamI( "OscEn", 1 );

}

////////////////////////////////////////////////
void OscillViewCh13()
{
  // Source
  _SetParamValue( "OscData", 1, 0 );
  _SetParamValue( "OscSelData", 0, 0 );
  _openSubOscillWnd(0);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 28);
  _SetParamValue( "OscSelTrigger", 0, 28);
  // start
  _WriteParamI( "OscEn", 1 );

}

////////////////////////////////////////////////
void OscillViewCh14()
{
  // Source
  _SetParamValue( "OscData", 1, 0 );
  _SetParamValue( "OscSelData", 0, 0 );
  _openSubOscillWnd(0);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 29);
  _SetParamValue( "OscSelTrigger", 0, 29);
  // start
  _WriteParamI( "OscEn", 1 );

}

////////////////////////////////////////////////
void OscillViewCh21()
{
  // Source
  _SetParamValue( "OscData", 1, 1 );
  _SetParamValue( "OscSelData", 0, 1 );
  _openSubOscillWnd(1);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 30);
  _SetParamValue( "OscSelTrigger", 0, 30);
  // start
  _WriteParamI( "OscEn", 1 );

}

////////////////////////////////////////////////
void OscillViewCh22()
{
  // Source
  _SetParamValue( "OscData", 1, 1 );
  _SetParamValue( "OscSelData", 0, 1 );
  _openSubOscillWnd(1);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 31);
  _SetParamValue( "OscSelTrigger", 0, 31);
  // start
  _WriteParamI( "OscEn", 1 );

}

////////////////////////////////////////////////
void OscillViewCh23()
{
  // Source
  _SetParamValue( "OscData", 1, 1 );
  _SetParamValue( "OscSelData", 0, 1 );
  _openSubOscillWnd(1);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 32);
  _SetParamValue( "OscSelTrigger", 0, 32);
  // start
  _WriteParamI( "OscEn", 1 );

}

////////////////////////////////////////////////
void OscillViewCh24()
{
  // Source
  _SetParamValue( "OscData", 1, 1 );
  _SetParamValue( "OscSelData", 0, 1 );
  _openSubOscillWnd(1);
  // Trigger
  _SetParamValue( "OscTrigger", 1, 33);
  _SetParamValue( "OscSelTrigger", 0, 33);
  // start
  _WriteParamI( "OscEn", 1 );

}
////////////////////////////////////////////////
void OscillStart_PLUS()
{
   _IncParam( "OscStart", 10 );
}
////////////////////////////////////////////////
void OscillStart_MINUS()
{
  _IncParam( "OscStart", -10 );
}
////////////////////////////////////////////////
void OscillStart_MPLUS()
{
  _IncParam( "OscStart", 60 );
}
////////////////////////////////////////////////
void OscillStart_MMINUS()
{
  _IncParam( "OscStart", -60 );
}
////////////////////////////////////////////////
void OscillStart_SET()
{
  _CopyParamM( "OscStart", 1, "OscSelStart", 0, 10.0);
}



////////////////////////////////////////////////
void  _TestInjImpulse( int test_num )
{
  _WriteParamI( "TestInjCh", test_num );
}

////////////////////////////////////////////////
void TestInj_1CH()
{
  _TestInjImpulse( 1 );
}
////////////////////////////////////////////////
void TestInj_2CH()
{
  _TestInjImpulse( 2 );
}
////////////////////////////////////////////////
void TestInj_3CH()
{
  _TestInjImpulse( 3 );
}
////////////////////////////////////////////////
void TestInj_4CH()
{
  _TestInjImpulse( 4 );
}
////////////////////////////////////////////////
void TestInj_5CH()
{
  _TestInjImpulse( 5 );
}
////////////////////////////////////////////////
void TestInj_6CH()
{
  _TestInjImpulse( 6 );
}
////////////////////////////////////////////////
void TestInj_7CH()
{
  _TestInjImpulse( 7 );
}
////////////////////////////////////////////////
void TestInj_8CH()
{
  _TestInjImpulse( 8 );
}

////////////////////////////////////////////////
void TestInj_1CYL()
{
  _TestInjImpulse( 16 );
}
////////////////////////////////////////////////
void TestInj_2CYL()
{
  _TestInjImpulse( 17 );
}
////////////////////////////////////////////////
void TestInj_3CYL()
{
  _TestInjImpulse( 18 );
}
////////////////////////////////////////////////
void TestInj_4CYL()
{
  _TestInjImpulse( 19 );
}
////////////////////////////////////////////////
void TestInj_5CYL()
{
  _TestInjImpulse( 20 );
}
////////////////////////////////////////////////
void TestInj_6CYL()
{
  _TestInjImpulse( 21 );
}
////////////////////////////////////////////////
void TestInj_7CYL()
{
  _TestInjImpulse( 22 );
}
////////////////////////////////////////////////
void TestInj_8CYL()
{
  _TestInjImpulse( 23 );
}

////////////////////////////////////////////////
void TestInj_Loop1()
{
  _TestInjImpulse( 100 );
}

////////////////////////////////////////////////
void TestInj_Loop2()
{
  _TestInjImpulse( 200 );
}

////////////////////////////////////////////////
void TestInj_StopLoop()
{
  _TestInjImpulse( 0 );
}

////////////////////////////////////////////////
void Calculator_SETFREQ()
{
  _CopyParam( "ClcFreq", 0, "N", 1);
}


////////////////////////////////////////////////
void  _TestInjOff( int test_num )
{
  _WriteParamI( "TestInjOff", test_num );
}

////////////////////////////////////////////////
void TestInjOff_1CH()
{
  _TestInjOff(1);
}
////////////////////////////////////////////////
void TestInjOff_2CH()
{
  _TestInjOff(2);
}
////////////////////////////////////////////////
void TestInjOff_3CH()
{
  _TestInjOff(3);
}
////////////////////////////////////////////////
void TestInjOff_4CH()
{
  _TestInjOff(4);
}
////////////////////////////////////////////////
void TestInjOff_5CH()
{
  _TestInjOff(5);
}
////////////////////////////////////////////////
void TestInjOff_6CH()
{
  _TestInjOff(6);
}
////////////////////////////////////////////////
void TestInjOff_7CH()
{
  _TestInjOff(7);
}
////////////////////////////////////////////////
void TestInjOff_8CH()
{
  _TestInjOff(8);
}

////////////////////////////////////////////////
void TestInjOff_1CYL()
{
  _TestInjOff(16);
}
////////////////////////////////////////////////
void TestInjOff_2CYL()
{
  _TestInjOff(17);
}
////////////////////////////////////////////////
void TestInjOff_3CYL()
{
  _TestInjOff(18);
}
////////////////////////////////////////////////
void TestInjOff_4CYL()
{
  _TestInjOff(19);
}
////////////////////////////////////////////////
void TestInjOff_5CYL()
{
  _TestInjOff(20);
}
////////////////////////////////////////////////
void TestInjOff_6CYL()
{
  _TestInjOff(21);
}
////////////////////////////////////////////////
void TestInjOff_7CYL()
{
  _TestInjOff(22);
}
////////////////////////////////////////////////
void TestInjOff_8CYL()
{
  _TestInjOff(23);
}
////////////////////////////////////////////////
void TestInjOff_Stop()
{
  _TestInjOff(255);
}

//=======================================================================================
////////////////////////////////////////////////


////////////////////////////////////////////////


//-------------------------------------------

int CallSTRBLI( int RoutineLI, int arg1 ,string  msg)
{
  int arrCmdParams[MAX_SERVICE_DATA_SIZE];
  int fldn;
  int pvalue = 0;

  arrCmdParams[0] = RoutineLI;
  arrCmdParams[1] = arg1;

   akmPrint(": ");
   akmPrint(stdItoA(RoutineLI));
   akmPrint(": ");
   akmPrint(stdItoA(arg1));
   akmPrint("\n");

 fldn =  akmDataSrcPerformKwpCommand(
//  MODEL_NAME,       // STK_PARAM_STRING sModelName,  // IN
    akmGetModelName(1),
    KWP_STRBLI,          // STK_PARAM_INT    kwpCommand,  // IN
    arrCmdParams,        // STK_PARAM_INT    arrCmdParams[MAX_SERVICE_DATA_SIZE],  // IN
    2,                   // STK_PARAM_INT    cmdCount,                             // IN
    1000,                // STK_PARAM_INT    timeout,                              // IN
    arrCmdParams         // STK_PARAM_INT    arrResult[MAX_SERVICE_DATA_SIZE]      // OUT
    );


 if( fldn > 0 )
    if( msg )  stdMessageBox( msg,"KWP",MB_OK|MB_ICONINFORMATION);

 else     stdMessageBox( "  ","KWP",MB_OK|MB_ICONERROR);


 return pvalue;
}
////////////////////////////////////////////////
void Calibr_EGR()
{
   akmPrint(" EGR\n");
   CallSTRBLI( 0x19, 0,"  EGR ");
}
//-------------------------------------------

void TEST_AVZ()
{

   akmPrint("TEST_AVZ\n");
  CallSTRBLI( 0x16, 1,"   ");
}
//-------------------------------------------


////////////////////////////////////////////////
void _ClearErrAction( int eact )
{
  _WriteParamI( "eactControl", 100+eact );
}

////////////////////////////////////////////////
void ErrActionClearAll()
{
  _ClearErrAction(-1);
}
////////////////////////////////////////////////
void ErrActionClearCounters()
{
  _ClearErrAction(-2);
}

////////////////////////////////////////////////
void ErrActionClear1()
{
  _ClearErrAction(1);
}
////////////////////////////////////////////////
void ErrActionClear2()
{
  _ClearErrAction(2);
}
////////////////////////////////////////////////
void ErrActionClear3()
{
  _ClearErrAction(3);
}
////////////////////////////////////////////////
void ErrActionClear4()
{
  _ClearErrAction(4);
}
////////////////////////////////////////////////
void ErrActionClear5()
{
  _ClearErrAction(5);
}
////////////////////////////////////////////////
void ErrActionClear6()
{
  _ClearErrAction(6);
}
////////////////////////////////////////////////
void ErrActionClear7()
{
  _ClearErrAction(7);
}


////////////////////////////////////////////////
void WdtTest1()
{
  _WriteParamI( "WDTtest", 1 );
}

////////////////////////////////////////////////
void WdtTest2()
{
  _WriteParamI( "WDTtest", 2 );
}


////////////////////////////////////////////////
void Pf0TestStop()
{
  _WriteParamI( "PF0test", 0 );
}
////////////////////////////////////////////////
void Pf0Test1()
{
  _WriteParamI( "PF0test", 1 );
}
////////////////////////////////////////////////
void Pf0Test2()
{
  _WriteParamI( "PF0test", 2 );
}
////////////////////////////////////////////////
void Pf0TestOpen()
{
  _WriteParamI( "PF0test", 11 );
}
////////////////////////////////////////////////
void Pf0TestMeu()
{
  _WriteParamI( "PF0test", 12 );
}


////////////////////////////////////////////////
void NxxTestStop()
{
  _WriteParamI( "NXXtest", 0 );
}
////////////////////////////////////////////////
void NxxTest1()
{
  _WriteParamI( "NXXtest", 1 );
}

////////////////////////////////////////////////
void AccTestStop()
{
  _WriteParamI( "AccTest", 0 );
}

////////////////////////////////////////////////
void AccTestSpeedUp()
{
  _WriteParamI( "AccTest", 1 );
}
////////////////////////////////////////////////
void AccTestSpeedDown()
{
  _WriteParamI( "AccTest", 2 );
}


////////////////////////////////////////////////
void Syn1TestOnOff()
{
  _WriteParamI( "Syn12Test", 1 );
}
////////////////////////////////////////////////
void Syn2TestOnOff()
{
  _WriteParamI( "Syn12Test", 2 );
}

////////////////////////////////////////////////
void CCpultPlusKey()
{
  _WriteParamI( "CCpult_test", 1 );
}
////////////////////////////////////////////////
void CCpultMemKey()
{
  _WriteParamI( "CCpult_test", 2 );
}
////////////////////////////////////////////////
void CCpultMinusKey()
{
  _WriteParamI( "CCpult_test", 4 );
}
////////////////////////////////////////////////
void CCpultAusKey()
{
  _WriteParamI( "CCpult_test", 8 );
}
////////////////////////////////////////////////
void CCpultModeKey()
{
  _WriteParamI( "CCpult_test", 16 );
}


////////////////////////////////////////////////

////////////////////////////////////////////////
void PcvTest1()
{
  _WriteParamI( "PCVtest", 1 );
}

////////////////////////////////////////////////
////////////////////////////////////////////////
void EcuLinkStatusChange( )
{

  if( _GetParamI("EcuLinkStatus") )
  {
    print "Reload Osc Data\n";
/*
    _CopyParam( "OscSelStart",   0, "OscStart",   1 );
    _CopyParamM( "OscSelData",    0, "OscData",    1 , 10.0);
    _CopyParam( "OscSelTrigger", 0, "OscTrigger", 1 );
    _CopyParam( "OscSelPeriod",  0, "OscPeriod",  1 );
*/
  }

}

////////////////////////////////////////////////
////////////////////////////////////////////////
void AkmTimeEvent( void )
{

  akm_time_cnt++;

  if( !sub_window_control && akm_time_cnt > 150 )
   sub_window_control = 1;
  
}
